/***************************************************************************
 *   Copyright (C) 2010 by Koptsow Dmitry   *
 *   suslic2012.at.gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DIRITEM_H
#define DIRITEM_H

#include <QDebug>
#include <QVariant>
#include <QIcon>
#include <QList>

#include <iostream>

class DirItem
{
	public:
		DirItem ( DirItem* parent = 0 );
		DirItem ( const QList<QVariant> list, DirItem* parent = 0 );
		~DirItem();
		DirItem* mparent;
		DirItem* mnext;
		DirItem* fchild;
		DirItem* childAt ( int row );
		DirItem* lastChild();
		int myRow();
		int columns();
		int children();
		int rowOfChild ( DirItem* child );
		QVariant dataAt ( int column );
		void setData ( QVariant data, int column );
		void setAllData ( const QList<QVariant> data );
		void setDataforAll ( QVariant data, int column );
		void createFChild ( const QList<QVariant> list = QList<QVariant>() );
		void createNextChild ( const QList<QVariant> list = QList<QVariant>() );
		bool appendChild ( const QList<QVariant> list = QList<QVariant>() );
		void insertChild ( DirItem* child, int row );
		QStringList getDirData ( bool include_my_data );
		bool transferChildren();
		void removeFChild();
		void removeNextChild();
		void reset();
		void print();
	private:
		QList<QVariant> properties; //0 - full path, 1 - "true"/"false" - checked , 2 - "true"/"false" - if base
};

#endif
