/***************************************************************************
 *   Copyright (C) 2010 by Koptsow Dmitry   *
 *   suslic2012.at.gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DIRMODEL_H
#define DIRMODEL_H

#include <QAbstractItemModel>
#include <QList>
#include <QIcon>
#include <QFont>

#include "DirItem.h"

class DirModel : public QAbstractItemModel
{
		Q_OBJECT
	public:
		DirModel ( QObject *parent = 0 );
		~DirModel();
		QModelIndex index ( int row, int column, const QModelIndex &index = QModelIndex() ) const;
		QModelIndex parent ( const QModelIndex &index ) const;
		int rowCount ( const QModelIndex &index = QModelIndex() ) const;
		bool hasChildren ( const QModelIndex & index = QModelIndex() ) const;
		int columnCount ( const QModelIndex &index = QModelIndex() ) const;
		QVariant data ( const QModelIndex &index, int role ) const;
		Qt::ItemFlags flags ( const QModelIndex &index ) const;
		QVariant headerData ( int section, Qt::Orientation orientation, int role = Qt::DisplayRole ) const;
		//bool insertRow ( int pos, const QModelIndex &index = QModelIndex() );
		//bool insertRows ( int pos, int rows, const QModelIndex &index = QModelIndex() );
		//bool removeRow ( int pos, const QModelIndex &index = QModelIndex() );
		//bool removeRows ( int pos, int rows, const QModelIndex &index = QModelIndex() );
		void removeAt ( QModelIndex index );
		DirItem* getRoot();
		DirItem* getBase();
		void setup ( QStringList allDirs );
		void changeDataAtIndex ( QModelIndex index, QVariant data );
		void switchDataAtIndex ( QModelIndex index, bool subdirs );
		bool setFirstAsBase();
		int childrenAtIndex ( QModelIndex index );
		bool containsBaseItem ( QModelIndex index );
	signals:
		void dir_added ( int i );
	private:
		DirItem *root;
		DirItem *baseItem;
};

#endif
