/***************************************************************************
 *   Copyright (C) 2009 by Koptsow Dmitriy   *
 *   suslic-2012@rambler.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef QRCGENERATOR_H
#define QRCGENERATOR_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QComboBox>
#include <QtGui/QWidget>
#include <QtGui/QFrame>
#include <QtGui/QGridLayout>
#include <QtGui/QGroupBox>
#include <QtGui/QHBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLineEdit>
#include <QtGui/QPlainTextEdit>
#include <QtGui/QTextBrowser>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QToolButton>
//#include <QtGui/QTreeWidget>
#include <QtGui/QListWidget>
#include <QtGui/QTreeView>
#include <QtGui/QVBoxLayout>
#include <QCloseEvent>
#include <QClipboard>
#include <QDirIterator>
#include <QFileDialog>
#include <QMessageBox>
#include <QTextStream>
//#include <QFileSystemModel>
#include <QProgressBar>
#include <QMap>
#include <QTimer>
#include "DirModel.h"

static QString version="0.1alpha";

/*struct DirBool
{
	QString directory;
	bool add;
	DirBool(QString s, bool b)
	{
		directory = s;
		add = b;
	};
};*/

class QRCGenerator : public QWidget
{
		Q_OBJECT

	public:
		QRCGenerator();
		~QRCGenerator();
		void retranslateUi();
		void initGUI();
		bool process_args ( QStringList args );
	protected:
		void closeEvent ( QCloseEvent *event );
	private slots:
		void on_aboutButton_clicked();
		void on_closeButton_clicked();
		void on_saveButton_clicked();
		void on_copyButton_clicked();
		void on_clearButton_clicked();
		void on_helpTool_clicked();
		void on_addButton_clicked();
		void on_removeButton_clicked();
		void on_generateButton_clicked();

		void on_langCheck_clicked ( bool sel );
		void on_aliasCheck_clicked ( bool sel );
		void on_prefixCheck_clicked ( bool sel );

		void on_addFormat_clicked();
		void on_addImgFormats_clicked();
		void on_removeFormats_clicked();
		void on_clearFormats_clicked();

		//void on_langCombo_activated ( int index );
		//void on_treeWidget_itemClicked ( QTreeWidgetItem * item, int column );

		void hideBrower_timeout();
		//void view_entered ( QModelIndex index );
		void view_clicked ( QModelIndex index );
		void view_doubleClicked ( QModelIndex index );

	private:
		void readSettings();
		void writeSettings();
		void readLangData();
		int question ( QString fname );
		QString gen_output ( QString baseD, QStringList* allDirs, QString prefix, QString alias, QString lang, QString dollar );
		void print_help();
		void print_lang();
		bool saveCore ( QString file, QString* data , int overwrite=0 );

		QString baseDir;
		QMap<QString, QString> langData;
		QStringList formats, imgformats;
		QString imgformat;
		QString lastdir;

		QTimer* hideBrowser;
		QClipboard* clip;
		QVBoxLayout *verticalLayout_3;
		QGroupBox *groupBox;
		QVBoxLayout *inputLayout;
		QFrame *frame;
		QVBoxLayout *verticalLayout_4;
		QHBoxLayout *horizontalLayout_3;
		//QTreeWidget *treeWidget;
		QTreeView* treeView;
		DirModel* model;
		QVBoxLayout *verticalLayout_2;
		QToolButton *addButton;
		QToolButton *removeButton;

		QHBoxLayout *twogroupHLayout;

		QGroupBox *groupBox_3;
		QGridLayout *gridLayout;
		QCheckBox *langCheck;
		QComboBox *langCombo;
		QCheckBox *aliasCheck;
		QHBoxLayout *horizontalLayout_2;
		QComboBox *aliasEdit;
		QToolButton *helpTool;
		QCheckBox *prefixCheck;
		QComboBox *prefixEdit;
		QCheckBox *subdirCheck;

		QGroupBox *formatsGroup;
		QHBoxLayout *formatsLayout;
		QListWidget *formatsList;
		QVBoxLayout *formatToolsL;
		QToolButton *addFormat;
		QToolButton *addImgFormats;
		QToolButton *removeFormats;
		QToolButton *clearFormats;


		QGroupBox *groupBox_2;
		QHBoxLayout *horizontalLayout;
		QPlainTextEdit *plainTextEdit;
		QTextBrowser* textBrowser;
		QVBoxLayout *verticalLayout;
		QPushButton *saveButton;
		QPushButton *copyButton;
		QPushButton *clearButton;
		QHBoxLayout *horizontalLayout_5;
		QPushButton *generateButton;
		//QSpacerItem *horizontalSpacer;
		QProgressBar* progBar;
		QPushButton *aboutButton;
		QPushButton *closeButton;

};

#endif
