/***************************************************************************
 *   Copyright (C) 2009 by Koptsow Dmitriy   *
 *   suslic-2012@rambler.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "qrcgenerator.h"


void QRCGenerator::initGUI()
{
	setWindowFlags ( Qt::WindowMinMaxButtonsHint|Qt::WindowCloseButtonHint );
	clip = qApp->clipboard();
	this->resize ( 813, 662 );
	setObjectName ( QString::fromUtf8 ( "QRCGenerator" ) );

	verticalLayout_3 = new QVBoxLayout ( this );
	verticalLayout_3->setObjectName ( QString::fromUtf8 ( "verticalLayout_3" ) );
	groupBox = new QGroupBox ( this );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	inputLayout = new QVBoxLayout ( groupBox );
	inputLayout->setObjectName ( QString::fromUtf8 ( "inputLayout" ) );
	frame = new QFrame ( groupBox );
	frame->setObjectName ( QString::fromUtf8 ( "frame" ) );
	frame->setFrameShape ( QFrame::StyledPanel );
	frame->setFrameShadow ( QFrame::Raised );
	verticalLayout_4 = new QVBoxLayout ( frame );
	verticalLayout_4->setObjectName ( QString::fromUtf8 ( "verticalLayout_4" ) );
	horizontalLayout_3 = new QHBoxLayout();
	horizontalLayout_3->setObjectName ( QString::fromUtf8 ( "horizontalLayout_3" ) );

	treeView = new QTreeView ( frame );
	model = new DirModel();

	treeView->setModel ( model );
	//treeView->setMouseTracking ( true );
	treeView->setExpandsOnDoubleClick ( false );


	horizontalLayout_3->addWidget ( treeView );

	verticalLayout_2 = new QVBoxLayout();
	verticalLayout_2->setObjectName ( QString::fromUtf8 ( "verticalLayout_2" ) );

	addButton = new QToolButton ( frame );
	addButton->setObjectName ( QString::fromUtf8 ( "addButton" ) );

	verticalLayout_2->addWidget ( addButton );

	removeButton = new QToolButton ( frame );
	removeButton->setObjectName ( QString::fromUtf8 ( "removeButton" ) );

	verticalLayout_2->addWidget ( removeButton );

	verticalLayout_2->addStretch();


	horizontalLayout_3->addLayout ( verticalLayout_2 );


	verticalLayout_4->addLayout ( horizontalLayout_3 );


	inputLayout->addWidget ( frame );

	twogroupHLayout = new QHBoxLayout();
	twogroupHLayout->setObjectName ( QString::fromUtf8 ( "twogroupHLayout" ) );

	groupBox_3 = new QGroupBox ( groupBox );
	groupBox_3->setObjectName ( QString::fromUtf8 ( "groupBox_3" ) );

	gridLayout = new QGridLayout ( groupBox_3 );
	gridLayout->setObjectName ( QString::fromUtf8 ( "gridLayout" ) );

	langCheck = new QCheckBox ( groupBox_3 );
	langCheck->setObjectName ( QString::fromUtf8 ( "langCheck" ) );

	gridLayout->addWidget ( langCheck, 0, 0, 1, 1 );

	langCombo = new QComboBox ( groupBox_3 );
	langCombo->setObjectName ( QString::fromUtf8 ( "langCombo" ) );
	/////////////////////
	readLangData();
	/////////////////////

	gridLayout->addWidget ( langCombo, 0, 1, 1, 1 );

	aliasCheck = new QCheckBox ( groupBox_3 );
	aliasCheck->setObjectName ( QString::fromUtf8 ( "aliasCheck" ) );

	gridLayout->addWidget ( aliasCheck, 1, 0, 1, 1 );

	horizontalLayout_2 = new QHBoxLayout();
	horizontalLayout_2->setObjectName ( QString::fromUtf8 ( "horizontalLayout_2" ) );

	aliasEdit = new QComboBox ( groupBox_3 );
	aliasEdit->setObjectName ( QString::fromUtf8 ( "aliasEdit" ) );
	aliasEdit->setEditable ( true );

	horizontalLayout_2->addWidget ( aliasEdit );

	helpTool = new QToolButton ( groupBox_3 );
	helpTool->setObjectName ( QString::fromUtf8 ( "helpTool" ) );

	horizontalLayout_2->addWidget ( helpTool );


	gridLayout->addLayout ( horizontalLayout_2, 1, 1, 1, 1 );

	prefixCheck = new QCheckBox ( groupBox_3 );
	prefixCheck->setObjectName ( QString::fromUtf8 ( "prefixCheck" ) );

	gridLayout->addWidget ( prefixCheck, 2, 0, 1, 1 );

	prefixEdit = new QComboBox ( groupBox_3 );
	prefixEdit->setObjectName ( QString::fromUtf8 ( "prefixEdit" ) );
	prefixEdit->setEditable ( true );

	gridLayout->addWidget ( prefixEdit, 2, 1, 1, 1 );

	subdirCheck = new QCheckBox ( groupBox_3 );
	subdirCheck->setObjectName ( QString::fromUtf8 ( "subdirCheck" ) );

	gridLayout->addWidget ( subdirCheck, 3, 0, 1, 2 );

	twogroupHLayout->addWidget ( groupBox_3 );


	formatsGroup = new QGroupBox ( this );
	formatsGroup->setObjectName ( QString::fromUtf8 ( "formatsGroup" ) );

	formatsLayout = new QHBoxLayout ( formatsGroup );
	formatsLayout->setObjectName ( QString::fromUtf8 ( "formatsLayout" ) );

	formatsList = new QListWidget ( formatsGroup );
	formatsList->setObjectName ( QString::fromUtf8 ( "formatsList" ) );

	formatsLayout->addWidget ( formatsList );

	formatToolsL = new QVBoxLayout();
	formatToolsL->setObjectName ( QString::fromUtf8 ( "formatToolsL" ) );

	addFormat = new QToolButton ( formatsGroup );
	addFormat->setObjectName ( QString::fromUtf8 ( "addFormat" ) );
	formatToolsL->addWidget ( addFormat );

	addImgFormats = new QToolButton ( formatsGroup );
	addImgFormats->setObjectName ( QString::fromUtf8 ( "addImgFormats" ) );
	formatToolsL->addWidget ( addImgFormats );

	removeFormats = new QToolButton ( formatsGroup );
	removeFormats->setObjectName ( QString::fromUtf8 ( "removeFormats" ) );
	formatToolsL->addWidget ( removeFormats );

	clearFormats = new QToolButton ( formatsGroup );
	clearFormats->setObjectName ( QString::fromUtf8 ( "clearFormats" ) );
	formatToolsL->addWidget ( clearFormats );

	formatToolsL->addStretch();

	formatsLayout->addLayout ( formatToolsL );

	twogroupHLayout->addWidget ( formatsGroup );

	inputLayout->addLayout ( twogroupHLayout );

	verticalLayout_3->addWidget ( groupBox );


	groupBox_2 = new QGroupBox ( this );
	groupBox_2->setObjectName ( QString::fromUtf8 ( "groupBox_2" ) );
	horizontalLayout = new QHBoxLayout ( groupBox_2 );
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	plainTextEdit = new QPlainTextEdit ( groupBox_2 );
	plainTextEdit->setObjectName ( QString::fromUtf8 ( "plainTextEdit" ) );

	horizontalLayout->addWidget ( plainTextEdit );

	textBrowser = new QTextBrowser ( groupBox_2 );
	textBrowser->setObjectName ( QString::fromUtf8 ( "textBrowser" ) );
	textBrowser->hide();
	horizontalLayout->addWidget ( textBrowser );


	verticalLayout = new QVBoxLayout();
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );

	saveButton = new QPushButton ( groupBox_2 );
	saveButton->setObjectName ( QString::fromUtf8 ( "saveButton" ) );

	verticalLayout->addWidget ( saveButton );

	copyButton = new QPushButton ( groupBox_2 );
	copyButton->setObjectName ( QString::fromUtf8 ( "copyButton" ) );

	verticalLayout->addWidget ( copyButton );

	clearButton = new QPushButton ( groupBox_2 );
	clearButton->setObjectName ( QString::fromUtf8 ( "clearButton" ) );

	verticalLayout->addWidget ( clearButton );

	verticalLayout->addStretch();


	horizontalLayout->addLayout ( verticalLayout );


	verticalLayout_3->addWidget ( groupBox_2 );

	horizontalLayout_5 = new QHBoxLayout();
	horizontalLayout_5->setObjectName ( QString::fromUtf8 ( "horizontalLayout_5" ) );

	generateButton = new QPushButton ( this );
	generateButton->setObjectName ( QString::fromUtf8 ( "generateButton" ) );

	horizontalLayout_5->addWidget ( generateButton );

	//horizontalSpacer = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
	progBar = new QProgressBar ( this );
	progBar->setObjectName ( QString::fromUtf8 ( "progBar" ) );

	progBar->setFormat ( tr ( "Added %v of %m directories" ) );
	connect ( model, SIGNAL ( dir_added ( int ) ), progBar, SLOT ( setValue ( int ) ) );

	horizontalLayout_5->addStretch();
	horizontalLayout_5->addWidget ( progBar, 1 );

	progBar->hide();

	aboutButton = new QPushButton ( this );
	aboutButton->setObjectName ( QString::fromUtf8 ( "aboutButton" ) );

	horizontalLayout_5->addWidget ( aboutButton );

	closeButton = new QPushButton ( this );
	closeButton->setObjectName ( QString::fromUtf8 ( "closeButton" ) );

	horizontalLayout_5->addWidget ( closeButton );


	verticalLayout_3->addLayout ( horizontalLayout_5 );

	retranslateUi();

	hideBrowser = new QTimer ( this );

	QMetaObject::connectSlotsByName ( this );

	langCombo->setEnabled ( false );
	aliasEdit->setEnabled ( false );
	helpTool->setEnabled ( false );
	prefixEdit->setEnabled ( false );

	prefixEdit->setInsertPolicy ( QComboBox::InsertAtTop );
	aliasEdit->setInsertPolicy ( QComboBox::InsertAtTop );

	//qDebug() <<"init gui finished";
	//connect ( treeView, SIGNAL ( entered ( QModelIndex ) ), this, SLOT ( view_entered ( QModelIndex ) ) );
	connect ( treeView, SIGNAL ( clicked ( QModelIndex ) ), this, SLOT ( view_clicked ( QModelIndex ) ) );
	connect ( treeView, SIGNAL ( doubleClicked ( QModelIndex ) ), this, SLOT ( view_doubleClicked ( QModelIndex ) ) );
	connect ( hideBrowser, SIGNAL ( timeout() ), this, SLOT ( hideBrower_timeout() ) );
	//qDebug() <<"slots connected";

	readSettings();
}

void QRCGenerator::readLangData()
{
	QFile file ( ":/lang.rc" );
	if ( !file.open ( QFile::ReadOnly ) )
	{
		qDebug() <<"failed to read lang data";
		return;
	}
	QString all = file.readAll();
	foreach ( QString chop, all.split ( "\n", QString::SkipEmptyParts ) )
	{
		langData.insert ( chop.split ( "\t" ).first(), chop.split ( "\t" ).last() );
	}
	langCombo->addItems ( langData.uniqueKeys() );
}

void QRCGenerator::retranslateUi()
{
	setWindowTitle ( tr ( "QRCGenerator %1" ).arg ( version ) );
	groupBox->setTitle ( QApplication::translate ( "QRCGenerator", "Input:", 0, QApplication::UnicodeUTF8 ) );
	addButton->setIcon ( QIcon ( ":/list-add.svg" ) );
	removeButton->setIcon ( QIcon ( ":/list-remove.svg" ) );
	groupBox_3->setTitle ( QApplication::translate ( "QRCGenerator", "Options:", 0, QApplication::UnicodeUTF8 ) );
	langCheck->setText ( QApplication::translate ( "QRCGenerator", "&Language", 0, QApplication::UnicodeUTF8 ) );
	aliasCheck->setText ( QApplication::translate ( "QRCGenerator", "&Alias", 0, QApplication::UnicodeUTF8 ) );
	helpTool->setText ( QApplication::translate ( "QRCGenerator", "...", 0, QApplication::UnicodeUTF8 ) );
	prefixCheck->setText ( QApplication::translate ( "QRCGenerator", "&Prefix", 0, QApplication::UnicodeUTF8 ) );
	subdirCheck->setText ( QApplication::translate ( "QRCGenerator", "&Disable/Enable with subdirectories", 0, QApplication::UnicodeUTF8 ) );
	subdirCheck->setToolTip ( tr ( "If checked, when a directory from the list is enabled/disabled, all it's subdirectories will be also enabled/disabled" ) );
	groupBox_2->setTitle ( QApplication::translate ( "QRCGenerator", "Output:", 0, QApplication::UnicodeUTF8 ) );
	saveButton->setText ( QApplication::translate ( "QRCGenerator", "&Save", 0, QApplication::UnicodeUTF8 ) );
	saveButton->setIcon ( QIcon ( ":/document-save-as.svg" ) );
	copyButton->setText ( QApplication::translate ( "QRCGenerator", "&Copy", 0, QApplication::UnicodeUTF8 ) );
	copyButton->setIcon ( QIcon ( ":/edit-copy.svg" ) );
	clearButton->setText ( QApplication::translate ( "QRCGenerator", "C&lear", 0, QApplication::UnicodeUTF8 ) );
	clearButton->setIcon ( QIcon ( ":/edit-clear.svg" ) );
	generateButton->setText ( QApplication::translate ( "QRCGenerator", "&Generate", 0, QApplication::UnicodeUTF8 ) );
	generateButton->setIcon ( QIcon ( ":/accessories-text-editor.svg" ) );
	aboutButton->setText ( QApplication::translate ( "QRCGenerator", "About", 0, QApplication::UnicodeUTF8 ) );
	aboutButton->setIcon ( QIcon ( ":/dialog-information.svg" ) );
	closeButton->setText ( QApplication::translate ( "QRCGenerator", "Close", 0, QApplication::UnicodeUTF8 ) );
	closeButton->setIcon ( QIcon ( ":/system-log-out.svg" ) );

	formatsGroup->setTitle ( QApplication::translate ( "QRCGenerator", "Formats:", 0, QApplication::UnicodeUTF8 ) );
	addFormat->setIcon ( QIcon ( ":/list-add.svg" ) );
	addFormat->setToolTip ( tr ( "Add format" ) );

	addImgFormats->setIcon ( QIcon ( ":/image-x-generic.svg" ) );
	addImgFormats->setToolTip ( tr ( "Add all image formats supported by QImageReader" ) );

	removeFormats->setIcon ( QIcon ( ":/list-remove.svg" ) );
	removeFormats->setToolTip ( tr ( "Remove selected formats" ) );

	clearFormats->setIcon ( QIcon ( ":/edit-clear.svg" ) );
	clearFormats->setToolTip ( tr ( "Clear formats list" ) );


	helpTool->setIcon ( QIcon ( ":/help-browser.svg" ) );
}

/*treeWidget = new QTreeWidget ( frame );
treeWidget->setObjectName ( QString::fromUtf8 ( "treeWidget" ) );
treeWidget->setEditTriggers ( QAbstractItemView::NoEditTriggers );
treeWidget->setAutoExpandDelay ( 5 );
treeWidget->setColumnCount ( 1 );
treeWidget->setUniformRowHeights ( true );
treeWidget->setSortingEnabled ( false );

QTreeWidgetItem *qtreewidgetitem = treeWidget->headerItem();
qtreewidgetitem->setText ( 0, QApplication::translate ( "QRCGenerator", "Directory/File", 0, QApplication::UnicodeUTF8 ) );

horizontalLayout_3->addWidget ( treeWidget );*/
